#include "framebuffer.h"
#include "v3.h"
#include <iostream>
#include "scene.h"

FrameBuffer::FrameBuffer(int u0, int v0, 
  int _w, int _h) : Fl_Gl_Window(u0, v0, _w, _h, 0) {

  w = _w;
  h = _h;
  pix = new unsigned int[w*h];
  Set(0xFFFFFFFF);

}


void FrameBuffer::draw() {

  glDrawPixels(w, h, GL_RGBA, GL_UNSIGNED_BYTE, pix);

}

void FrameBuffer::Set(unsigned int color) {

  for (int i = 0; i < w*h; i++)
    pix[i] = color;

}

void FrameBuffer::Set(int u, int v, unsigned int color) {

  pix[w*(h-1-v)+u] = color;

}

void FrameBuffer::SetAsChecker(int cs, unsigned int cols[2]) {

  for (int v = 0; v < h; v++) {
    for (int u = 0; u < w; u++) {
      int cu = u/cs;
      int cv = v/cs;
      int i = (cu+cv)%2;
      Set(u, v, cols[i]);
    }
  }

}
